/* DSP LABORATORY 
 * University of Technology Graz, 2018
 * Josef Kulmer
 */

#ifndef FOURIERTRANSFORM_H
#define FOURIERTRANSFORM_H

#include <fftw3.h>
#include <vector>
#include <random>
#include <fstream>

class Fouriertransform{
private:
    const int AVERAGING = 10; // number of averaging
    const float ADDNOISE = .000001; // add artificial noise with range 0-1
    
    fftw_complex *inft, *outft;
    fftw_plan p;
    std::vector<double> windowfcn; // store hamming window
    std::vector<double> welch; // results of the PSD estimation
    std::vector<double> welchInternal; // internal buffer for PSD
    
    std::default_random_engine re; // required for random generator
    std::uniform_real_distribution<float> unif;
    const float PI = 3.141592654;
    int filewrite; // check whether file output is written
    int iAVERAGING;
public:
    Fouriertransform();
    ~Fouriertransform();
    // do Power Spectral Density estimation
    void doPSD(const void *, const void *, unsigned long); 
};

#endif /* FOURIERTRANSFORM_H */

